@ECHO OFF
COLOR 0C
ECHO.
ECHO.
ECHO                                                       #*****        @#*#****
ECHO                                                        ******      @#********@
ECHO                                                         ******@     #******@
ECHO  #####   #####    ####    ####   ##  ##  ##       ####   @*****@  @******#
ECHO  ##  ##  ##  ##  ##  ##  ##  ##  ##  ##  ##      ##  ##    @#**********#
ECHO  ##  ##  #####   ######  ##      ##  ##  ##      ######      @********@
ECHO  ##  ##  ##  ##  ##  ##  ##  ##  ##  ##  ##      ##  ##      @#######
ECHO  #####   ##  ##  ##  ##   ####    ####   ######  ##  ##    @@#######@
ECHO                                                          @@@@@@@@@@@@@
ECHO          R  o  n  d  o    o  f    B  l  o  o  d         @@@@@@@#  @@@@@
ECHO                                                      O@@@@@@@@@    #@@@@@
ECHO               ~English Translation Patch~           @@@@@@@@%       O@@@@@
ECHO                                                   #@@@@              @@@@@
ECHO                                                 %@@@@@                 @@@@
ECHO                                               %*@@@@                     @@%
ECHO                                             **@                           
ECHO -------------------------------------------------------------------------------
ECHO Team: Burnt Lasagna, cubanraul, pemdawg and tomaitheous.  
ECHO -------------------------------------------------------------------------------
ECHO  Press any key to patch the game...
pause>nul 
:FIRST
IF EXIST backup\*.bak GOTO WARNING
ECHO Checking ISO Integrity...
FOR /F "tokens=*" %%I IN ('FileBySize *.iso 20785152 /s') DO SET ISONAME="%%I"

IF EXIST %ISONAME% GOTO AUDIO
IF [%ISONAME%]==[] SET ISONAME="02 Akumajou Dracula X - Chi no Rondo (J).iso"
IF NOT EXIST %ISONAME% SET ISONAME="Dracula X T02 Mode1 2048.iso"

Rem Failed to detect a valid track 2 for some reason...
IF NOT EXIST %ISONAME% GOTO FATAL

GOTO AUDIO

:AUDIO
ECHO Converting OGG to WAV...
IF NOT EXIST ".\patch\sox.exe" GOTO MISSING
IF NOT EXIST ".\patch\Track21.ogg" GOTO MISSING
IF NOT EXIST ".\patch\Track19.ogg" GOTO MISSING
IF NOT EXIST ".\patch\Track03.ogg" GOTO MISSING
IF NOT EXIST ".\patch\Track20.ogg" GOTO MISSING
CD patch
sox.exe Track21.ogg Track21.wav rate -v 44100
sox.exe Track03.ogg Track03.wav rate -v 44100
sox.exe Track19.ogg Track19.wav rate -v 44100
sox.exe Track20.ogg Track20.wav rate -v 44100
CD..
GOTO START 


:START
IF NOT EXIST ".\patch\ApplyPPF3.exe" GOTO MISSING
IF NOT EXIST ".\patch\draculax.ppf" GOTO MISSING
IF NOT EXIST ".\patch\Track03.wav" GOTO MISSING
IF NOT EXIST ".\patch\Track19.wav" GOTO MISSING
IF NOT EXIST ".\patch\Track20.wav" GOTO MISSING
IF NOT EXIST ".\patch\Track21.wav" GOTO MISSING


:VERIFY
FOR /F "tokens=*" %%I IN ( 'FileBySize *.wav 18778412 /s' ) DO SET TRACK03="%%I"
IF [%TRACK03%]==[] SET TRACK03="03 Akumajou Dracula X - Chi no Rondo (J).wav"

FOR /F "tokens=*" %%I IN ( 'FileBySize *.wav 21170396 /s' ) DO SET TRACK19="%%I"
IF EXIST %TRACK19% GOTO FOUND19 
	FOR /F "tokens=*" %%I IN ( 'FileBySize *.wav 21170396 /s' ) DO SET TRACK19="%%I"
	IF [%TRACK19%]==[] SET TRACK19="19 Akumajou Dracula X - Chi no Rondo (J).wav"
:FOUND19

FOR /F "tokens=*" %%I IN ('FileBySize *.wav 42599468 /s') DO SET TRACK20="%%I"
IF EXIST %TRACK20% GOTO FOUND20
	FOR /F "tokens=*" %%I IN ( 'FileBySize *.wav 42599468 /s' ) DO SET TRACK20="%%I"
	IF [%TRACK20%]==[] SET TRACK20="20 Akumajou Dracula X - Chi no Rondo (J).wav"
:FOUND20
																								 
FOR /F "tokens=*" %%I IN ('FileBySize *.wav 44746844 /s') DO SET TRACK21="%%I"
IF EXIST %TRACK21% GOTO FOUND21
	FOR /F "tokens=*" %%I IN ('FileBySize *.wav 44746844 /s') DO SET TRACK21="%%I"
	IF [%TRACK21%]==[] SET TRACK21="21 Akumajou Dracula X - Chi no Rondo (J).wav"
:FOUND21
IF NOT EXIST %track03% SET TRACK03="Dracula X T03 Audio 2352.wav"
IF NOT EXIST %track19% SET TRACK19="Dracula X T19 Audio 2352.wav"
IF NOT EXIST %track20% SET TRACK20="Dracula X T20 Audio 2352.wav"
IF NOT EXIST %track21% SET TRACK21="Dracula X T21 Audio 2352.wav"

IF NOT EXIST %track03% GOTO DAMAGED
IF NOT EXIST %track19% GOTO DAMAGED
IF NOT EXIST %track20% GOTO DAMAGED
IF NOT EXIST %track21% GOTO DAMAGED
 
:BACKUP
ECHO Backing up Japanese files to backup folder...
REN %track03% %track03%.bak
REN %track19% %track19%.bak
REN %track20% %track20%.bak
REN %track21% %track21%.bak
COPY /B /V %ISONAME% %ISONAME%.bak

MKDIR backup

MOVE *.bak backup

ECHO Moving English Audio Tracks...
COPY /B /V .\patch\Track03.wav %track03%
COPY /B /V .\patch\Track19.wav %track19%
COPY /B /V .\patch\Track20.wav %track20%
COPY /B /V .\patch\Track21.wav %track21%
cd patch
del Track03.wav
del Track19.wav
del Track20.wav
del Track21.wav
cd..
cls

:FINALSTEP
CLS
ECHO Patching ISO...
.\patch\APPLYPPF3.EXE a %ISONAME% .\patch\draculax.ppf

GOTO COMPLETE

:FATAL
CLS
ECHO.
ECHO.
ECHO.
ECHO                 ͻ
ECHO                                                              
ECHO                   Fatal error: ISO does not match valid MD5  
ECHO                                                              
ECHO                 ͼ
ECHO.
pause>nul
exit

:MISSING
CLS
ECHO.
ECHO.
ECHO.
ECHO                 ͻ
ECHO                                                              
ECHO                       A required patch file is missing!      
ECHO                                                              
ECHO                 ͼ
ECHO.
pause>nul
exit

:DAMAGED
CLS
ECHO.
ECHO.
ECHO.
ECHO        ͻ
ECHO                 Cannot auto detect audio track file names!         
ECHO        Ķ
ECHO                                                                    
ECHO                  you will have to manually copy the audio          
ECHO                    tracks over from the 'patch' folder.            
ECHO                                                                    
ECHO                 Press any key to continue with ISO patching        
ECHO                                                                    
ECHO        ͼ
ECHO.
ECHO.
pause>nul
GOTO FINALSTEP
exit

:WARNING
CLS
ECHO.
ECHO.
ECHO.
ECHO                 ͻ
ECHO                                                              
ECHO                       The game has already been patched!     
ECHO                                                              
ECHO                 ͼ
ECHO.
pause>nul
exit

:COMPLETE
CLS
ECHO.
ECHO.
ECHO.
ECHO                 ͻ
ECHO                                                              
ECHO                       The patching process is complete!      
ECHO                                                              
ECHO                 ͼ
ECHO.
pause>nul
exit